package com.xiaqiuchu.demo.service;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNotEquals;

import java.util.List;

import javax.annotation.Resource;

import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.transaction.annotation.Transactional;

import com.xiaqiuchu.demo.entity.Student;

@SpringBootTest
public class StudentServiceTest {

    @Resource
    StudentService studentService;

    @Test
    void testFindById() {
       Student student = studentService.findById(1L);
       System.out.println(student.getName());
       assertEquals(student.getId(), 1L);
    }

    @Test
    void testSelectAll() {
        List<Student> studentList = studentService.selectAll();
       System.out.println(studentList.size());
       assertEquals(studentList.get(0).getId(), 1L);
    }

    @Test
    void testFindStudentAndTeamById() {
        Student student = studentService.findStudentAndTeamById(1L);
       System.out.println(student.getTeam().getName());
       assertEquals(student.getId(), 1L);
    }

    
    @Test
    // 在测试中，开启事务会自动回滚（不在测试中的时候捕获到受查异常时，会自动回滚。）
    @Transactional
    void testUpdateNameById() {
        Integer updateNum = studentService.updateNameById(1L, "王小黑");
        assertNotEquals(updateNum, 0);
    }
}
